<template>
  <div
    class="order-step__sides"
    v-if="baseLocations.consignee && baseLocations.consignor"
  >
    <h2 :class="{ active: isValid }" class="order-step-title">
      Грузоотправители и грузополучатели
      <i class="icon checked" />
    </h2>
    <div class="order-step__cards-container">
      <div class="order-step__card">
        <div class="order-step__card-header">
          Грузоотправители
          {{ filledConsignor }}
          /{{ brifPointConsignor && brifPointConsignor.length }}
        </div>
        <div
          class="order-step__card-item"
          v-for="point in consignorLogchainPoints"
          :key="point.pointName"
        >
          <div class="order-step__card-city">
            {{ point.pointName }}
          </div>
          <template v-if="brifPointConsignor && brifPointConsignor.length">
            <ob-card
              v-for="consignor in point.points"
              :key="consignor.uuid"
              @click="openVisitPointModal({ type: 'FROM', point: consignor })"
              type="down"
              :title="consignor.title || 'Указать грузоотправителя'"
              locationLabel="Фактический адрес"
              :date="formattedCardDate(consignor).date"
              :time="formattedCardDate(consignor).time"
              :location="consignor.address ? consignor.address : ''"
              :isDeleteAllowed="shouldShowAddConsignor && point.points.length > 1"
              data-qa="consignor"
              @delete="onDeletePoint(consignor)"
            />
          </template>
          <div class="order-step__point-add">
            <i class="icon plus" />
            <span @click="addVisitPoint(point, 'consignor')">
              Добавить грузоотправителя</span
            >
          </div>
        </div>
      </div>
      <div class="order-step__card">
        <div class="order-step__card-header">
          Грузополучатели
          {{ filledConsignee }}
          /{{ brifPointConsignee && brifPointConsignee.length }}
        </div>
        <div
          class="order-step__card-item"
          v-for="point in consigneeLogchainPoints"
          :key="point.pointName"
        >
          <div class="order-step__card-city">
            {{ point.pointName }}
          </div>
          <template v-if="brifPointConsignee">
            <ob-card
              v-for="consignee in point.points"
              :key="consignee.uuid"
              @click="openVisitPointModal({ type: 'TO', point: consignee })"
              type="up"
              :title="consignee.title || 'Указать грузополучателя'"
              locationLabel="Фактический адрес"
              :date="formattedCardDate(consignee).date"
              :time="formattedCardDate(consignee).time"
              :location="consignee.address ? consignee.address : ''"
              :isDeleteAllowed="shouldShowAddConsegnee && point.points.length > 1"
              data-qa="consignee"
              @delete="onDeletePoint(consignee)"
            />
          </template>
          <div class="order-step__point-add" v-if="shouldShowAddConsegnee">
            <i class="icon plus" />
            <span @click="addVisitPoint(point, 'consignee')">
              Добавить грузополучателя</span
            >
          </div>
        </div>
      </div>
    </div>

    <ob-modal
      ref="visitPointModal"
      :title="visitPointModalTitle"
      size="medium"
      :is-submit-disabled="true"
      :is-show-controls="false"
      :is-close-on-overlay="false"
      data-qa="orderConsigneeConsignorModal"
      @closed="onClose"
      @opened="onOpened"
    >
      <visit-point-modal
        ref="visitPointItem"
        :key="visitPointModalUuid"
        :visitPointUuid="visitPointModalUuid"
        :pvpDate="pvpDate"
        :locationsTypes="locationsTypes"
        :address="visitPointModalAddress"
        :contractorUuid="contractorUuid"
        :brif="brif"
        @visit-point-updated="handleVisitPointUpdated"
        @close="$refs.visitPointModal.close()"
      />
    </ob-modal>

    <ob-modal
      ref="deleteVisitPointModal"
      title="Удалить грузоотправителя"
      is-show-controls
      isError
      size="small"
      data-qa="deleteVisitPoint"
      okText="Удалить"
      cancelText="Не удалять"
      customClass="delete-visit-point-modal"
      @submit="onDeletePointSubmit"
    >
      <div class="delete-text">
        <span>Грузоотправитель:</span>
        {{ pointToDelete.title }}
      </div>
      <div class="delete-text">
        <span>Адрес:</span>
        {{ pointToDelete.address }}
      </div>
    </ob-modal>
  </div>
</template>

<script>
import cloneDeep from "clone-deep";
// import moment    from 'moment';
import api from "@/api";
import { uuid } from "vue-uuid";
import ObCard from "./visitPointCard";
import ObModal from "common-components/src/obComponents/obModal";
import VisitPointModal from "./modal/visitPointModal";

export default {
  components: {
    ObCard,
    ObModal,
    VisitPointModal,
  },

  props: {
    pvpDate: {
      type: String,
      required: true
    },
    isValid: {
      type: Boolean,
      required: true,
    },
    brif: {
      type: Object,
      required: true,
    },
    baseLocations: {
      type: Object,
      required: true,
    },
    addresses: {
      type: Object,
      required: true,
    },
    locationsTypes: {
      type: Array,
      required: true,
    },
    contractorUuid: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      pointToDelete: {},
      cardErrorMock: {
        date: "",
        location: "",
        locationDoc: "",
      },
      visitPointModalTitle: "",
      visitPointModalSubtitle: "",
      visitPointModalUuid: "",
      visitPointTimeSlotStartAt: "",
      visitPointModalAddress: "",
    };
  },

  computed: {
    shouldShowAddConsignor() {
      return this.brifPointConsignor.every(
        (item) => item.pointType !== "INFRASTRUCTURE_FACILITY"
      );
    },
    shouldShowAddConsegnee() {
      return this.brifPointConsignee.every(
        (item) => item.pointType !== "INFRASTRUCTURE_FACILITY"
      );
    },
    consignorLogchainPoints() {
      const arr = this.brifPointConsignor.reduce((acc, item) => {
        const existed = acc.find(point => point.pointName === item.logchainPointName);
        if (existed) {
          existed.points.push(item)
        } else {
          acc.push({
            pointName: item.logchainPointName,
            points: [item]
          });
        }
        // acc.push(item.logchainPointName);
        return acc;
      }, []);
      return [...new Set(arr)];
    },
    consigneeLogchainPoints() {
      const arr = this.brifPointConsignee.reduce((acc, item) => {
        const existed = acc.find(point => point.pointName === item.logchainPointName);
        if (existed) {
          existed.points.push(item)
        } else {
          acc.push({
            pointName: item.logchainPointName,
            points: [item]
          });
        }
        // acc.push(item.logchainPointName);
        return acc;
      }, []);
      return [...new Set(arr)];
    },
    filledConsignor() {
      return this.brifPointConsignee
        ? this.brifPointConsignor.reduce((acc, item) => {
            if (item.infographUuid) {
              acc += 1;
            }
            return acc;
          }, 0)
        : null;
    },

    filledConsignee() {
      return this.brifPointConsignee
        ? this.brifPointConsignee.reduce((acc, item) => {
            if (item.infographUuid) {
              acc += 1;
            }
            return acc;
          }, 0)
        : null;
    },

    hasVisitPoints() {
      return this.brif.visitPoints && this.brif.visitPoints.length;
    },
    visitPoints() {
      if (!this.hasVisitPoints) return;
      const brif = cloneDeep(this.brif);

      return brif.visitPoints;
    },
    brifPointConsignor() {
      return this.visitPoints
        ? this.visitPoints.filter((p) => p.type === "FROM")
        : null;
    },
    brifPointConsignee() {
      return this.visitPoints
        ? this.visitPoints.filter((p) => p.type === "TO")
        : null;
    },
  },

  methods: {
    async addVisitPoint(point, type) {
      const newUuid = uuid.v4();
      const typesMap = {
        consignor: {
          donorUuid: point.points[point.points.length - 1].uuid,
          routePointUuid: point.points[point.points.length - 1].routePointUuid,
        },
        consignee: {
          donorUuid: point.points[point.points.length - 1].uuid,
          routePointUuid: point.points[point.points.length - 1].routePointUuid,
        },
      };
      const { donorUuid, routePointUuid } = typesMap[type];
      try {
        const donor = await api.orders.getVisitPoint({ uuid: donorUuid });
        const newPoint = {
          ...donor.data,
          title: "",
          address: "",
          tsdAddress: "",
          code: "",
          comments: "",
          uuid: newUuid,
        };
        try {
          await api.orders.copyVisitPoint(newUuid, routePointUuid);
          this.$emit("visit-point-updated");
          this.openVisitPointModal({
            type: newPoint.consigneeOrConsignor,
            point: newPoint,
          });
        } catch (err) {
          console.error(err);
          this.$notification({
            type: "system_notification_error",
            message: "Ошибка при создании точки",
          });
        }
      } catch (err) {
        console.error(err);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка при создании точки",
        });
      }
    },
    onDeletePoint(point) {
      this.pointToDelete = { ...point };
      this.$refs.deleteVisitPointModal.open();
    },
    async onDeletePointSubmit() {
      try {
        await api.orders.deleteVisitPoint(this.pointToDelete.routePointUuid);
        await api.orders.recalculationDistancePrice(this.pointToDelete.uuid, this.$route.params.id);
        this.pointToDelete = {};
        this.$refs.deleteVisitPointModal.close();
        this.$emit("visit-point-updated");
      } catch (err) {
        console.error(err);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка при удалении",
        });
      }
    },
    formattedCardDate(point) {
      if (!point || !point.timeSlot || !point.timeSlot.date)
        return { date: "", time: "" };
      const { date, startT, endT } = point.timeSlot;
      const dateStart = new Date(`${date}T${startT}Z`);
      const dateEnd = new Date(`${date}T${endT}Z`);
      const timeOptions = {
        hour: "numeric",
        minute: "2-digit",
      };

      return {
        date: dateStart.toLocaleDateString("ru-RU"),
        time: `${dateStart.toLocaleTimeString(
          "ru-RU",
          timeOptions
        )}-${dateEnd.toLocaleTimeString("ru-RU", timeOptions)}`,
      };
    },
    onOpened() {
      this.$nextTick(() => {
        this.$refs.visitPointItem.init();
      });
    },
    onClose() {
      this.$refs.visitPointItem.handleCancel();
    },
    openVisitPointModal({ type, point }) {
      if (type === "FROM") {
        this.visitPointModalTitle = "Данные по грузоотправителю";
        this.visitPointModalSubtitle = `Добавление. ${this.baseLocations.consignor.russianName}`;
        this.visitPointModalUuid = point.uuid;
        this.visitPointTimeSlotStartAt = this.baseLocations.consignor.date;
        this.visitPointModalAddress = {
          ...this.addresses.consignor,
          ...this.baseLocations.consignor,
        };
      } else if (type === "TO") {
        this.visitPointModalTitle = "Данные по грузополучателю";
        this.visitPointModalSubtitle = `Добавление. ${this.baseLocations.consignee.russianName}`;
        this.visitPointModalUuid = point.uuid;
        this.visitPointTimeSlotStartAt = this.baseLocations.consignee.date;
        this.visitPointModalAddress = {
          ...this.addresses.consignee,
          ...this.baseLocations.consignee,
        };
      }

      this.$refs.visitPointModal.open();
    },

    handleVisitPointUpdated() {
      this.$emit("visit-point-updated");
    },
  },
};
</script>

<style lang="scss">
.order-step__sides {
  margin-top: 26px;
}

.order-step__cards-container {
  max-width: 885px;
  display: flex;
  justify-content: space-between;
}

.order-step__card {
  width: 45%;
  max-width: 390px;
}

.order-step__card-item {
  width: 100%;

  &:not(:last-child) {
    margin-bottom: 20px;
  }
}

.order-step__card-header {
  margin-bottom: 5px;
  font-size: 14px;
  color: $gray-slate;
}

.order-step__card-city {
  display: flex;
  justify-content: space-between;
  align-items: center;
  width: 100%;
  max-width: 410px;
  margin-bottom: 17px;
  font-size: 20px;
  font-weight: 700;
  line-height: 1.4;

  &.active {
    .icon {
      color: $color-green-light;
    }
  }

  .icon {
    display: flex;
    justify-content: flex-end;
    align-items: center;
    color: $color-grey-border;
  }
}

.order-step__point-add {
  display: inline-block;
  vertical-align: middle;
  font-size: 14px;
  line-height: 16px;
  letter-spacing: 0.2px;
  color: $color-blue-navy-blue;
  // padding: 10px 0 18px 20px;

  .icon {
    color: $color-grey-span;
  }

  span {
    cursor: pointer;
  }
}

.delete-text {
  display: flex;
  color: $style-black;

  span {
    min-width: 130px;
    margin-right: 8px;
    text-align: right;
    color: $shale-gray;
  }
}

.delete-text + .delete-text {
  margin-top: 10px;
}

.ob-modal-container .delete-visit-point-modal {
  padding: 40px 37px;
}
</style>